<?php
/**
 * The Header for our theme
 *
 * Displays all of the <head> section and everything up till <div id="main">
 *
 * @package WordPress
 */
?><!DOCTYPE html>
<!--[if IE 7]>
<html class="ie ie7" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 8]>
<html class="ie ie8" <?php language_attributes(); ?>>
<![endif]-->
<!--[if !(IE 7) | !(IE 8) ]><!-->
<html <?php language_attributes(); ?>>
<!--<![endif]-->
<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>">
	<meta name="viewport" content="width=device-width">
	<title><?php wp_title( '|', true, 'right' ); ?></title>
	<link rel="profile" href="http://gmpg.org/xfn/11">
	<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>">
    <link href='http://fonts.googleapis.com/css?family=Courgette' rel='stylesheet' type='text/css'>
	<!--[if lt IE 9]>
	<script src="<?php echo get_template_directory_uri(); ?>/js/html5.js"></script>
	<![endif]-->
	<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>
<div style="float: left; width: 100%; min-height: 888px;">

<div id="wrapper">
<div id="page">
<div id="header-section">
	<div class="logo"><a href="<?php echo bloginfo( 'url' ); ?>"><img src="<?php bloginfo('template_url')?>/images/logo.png" alt="logo" /></a></div>
    <div class="social-media">
    	<span>Follow us</span>
        <ul>
            <li><a target="_blank" href="<?php the_field('facebook_link',options); ?>" class="facebook" title="Facebook"></a></li>
            <li><a target="_blank" href="<?php the_field('twitter_link',options); ?>" class="twitter" title="Twitter"></a></li>
            <li><a target="_blank" href="<?php the_field('instagram_link',options); ?>" class="instagram" title="Instagram"></a></li>
        </ul>
    </div>
    <div class="main-menu-column">
    	<?php wp_nav_menu(array('theme_location'=>'primary','container'=>'false','menu_class'=>'main-menu',)); ?>	
    </div>
</div><!-- #header -->
	
</div>
</div>
