<?php
/**
 * Template Name: Brands Page Structure
 *
 * This is the template that displays all pages by default.
 * Please note that this is the WordPress construct of pages and that
 * other 'pages' on your WordPress site will use a different template.
 *
 * @package WordPress
*/

get_header(); ?>

<div id="main-content">
    <div class="subpage-banner" >
    	<?php
			if(get_field('subpage_banner'))
			{
			echo '<img src="' . get_field('subpage_banner') . '" />';
			
			} else { ?>
			<img src="<?php bloginfo('template_url')?>/images/default-banner.jpg" alt="banner" />
		<?php }	?>
    </div><!-- subpage-banner -->

<div id="page">    
    <div id="subpage-section">
    
   		<?php while ( have_posts() ) : the_post(); ?>
            <h1 class="page-title"><?php the_title(); ?></h1>
            <div class="page-content-column">
            	<div class="brand-left-column">
                	<?php the_content(); ?>
                </div>
                <div class="brand-right-column">
                	<?php $image_gallery = get_field('brand_gallery'); 
					if( $image_gallery ): ?>
                	<div class="brand-gallery-list">
                    	<h4>Photo Gallery</h4>
                    	<div class="scroll-pane">
							<ul>
                            	<?php foreach( $image_gallery as $image ): ?>
								<li><a class="group1" href="<?php echo $image['url']; ?>"><span class="roll-brand" ></span><img src="<?php echo $image['sizes']['thumbnail']; ?>" /></a></li>
                                <?php endforeach; ?>
							</ul>
                     	</div><!-- scroll-pane -->
					</div>
                    <?php endif; ?>
                    
				<!-- Youtube video -->
				<?php 
                $rows = get_field('brand_video_link');
                if($rows)
                {
                    echo '<div class="youtube-frame">';
                 	echo '<h4>Video Gallery</h4>';
                    foreach($rows as $row)
                    {
                        echo '<p><a class="youtube" href="'. $row['link'] . '" /><span class="play-icon" ></span><img src="'.$row['video_thumbnail_image'] .'" ></a></p>';
                    }
                    echo '</div>';
                }
                ?>
                <!-- End Youtube video -->
            
                </div>
            </div>
        <?php endwhile; // end of the loop. ?>
    </div> <!-- #subpage-section -->
    
</div>

</div>

<?php get_footer(); ?>
